Package: geb.navigator

## [Groovy] Class AbstractNavigator

- geb.navigator.AbstractNavigator

- All Implemented Interfaces and Traits:
    Navigator

      abstract class AbstractNavigator
      extends Object

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `Browser` | `browser`
    `Locator` | `locator`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `AbstractNavigator (Browser browser, BasicLocator basicLocator)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `Navigator` | `$(Map<String, Object> predicates)`
    `Navigator` | `$(Map<String, Object> predicates, int index)`
    `Navigator` | `$(Map<String, Object> predicates, Range<Integer> range)`
    `Navigator` | `$(Map<String, Object> predicates, String selector)`
    `Navigator` | `$(Map<String, Object> predicates, String selector, int index)`
    `Navigator` | `$(Map<String, Object> predicates, String selector, Range<Integer> range)`
    `Navigator` | `$(String selector)`
    `Navigator` | `$(String selector, int index)`
    `Navigator` | `$(String selector, Range<Integer> range)`
    `Navigator` | `$(Map<String, Object> predicates, By bySelector)`
    `Navigator` | `$(Map<String, Object> predicates, By bySelector, int index)`
    `Navigator` | `$(Map<String, Object> predicates, By bySelector, Range<Integer> range)`
    `Navigator` | `$(By bySelector)`
    `Navigator` | `$(By bySelector, int index)`
    `Navigator` | `$(By bySelector, Range<Integer> range)`
    `Navigator` | `add(String selector)`
    `Navigator` | `add(By bySelector)`
    `Navigator` | `add(WebElement[] elements)`
    `Navigator` | `add(Collection<WebElement> elements)`
    `boolean` | `asBoolean()`
    `String` | `attr(String name)`
    `String` | `css(String propertyName)`
    `Navigator` | `eq(int index)`
    `Navigator` | `filter(Map<String, Object> predicates, String selector)`
    `Navigator` | `find(Map<String, Object> predicates)`
    `Navigator` | `find(Map<String, Object> predicates, int index)`
    `Navigator` | `find(Map<String, Object> predicates, Range<Integer> range)`
    `Navigator` | `find(Map<String, Object> predicates, String selector)`
    `Navigator` | `find(Map<String, Object> predicates, String selector, int index)`
    `Navigator` | `find(Map<String, Object> predicates, String selector, Range<Integer> range)`
    `Navigator` | `find(String selector)`
    `Navigator` | `find(String selector, int index)`
    `Navigator` | `find(String selector, Range<Integer> range)`
    `Navigator` | `find(Map<String, Object> predicates, By bySelector)`
    `Navigator` | `find(Map<String, Object> predicates, By bySelector, int index)`
    `Navigator` | `find(Map<String, Object> predicates, By bySelector, Range<Integer> range)`
    `Navigator` | `find(By bySelector)`
    `Navigator` | `find(By bySelector, int index)`
    `Navigator` | `find(By bySelector, Range<Integer> range)`
    `Navigator` | `findAll(Closure predicate)`
    `WebElement` | `firstElement()`
    `protected WebElement` | `getElement(int index)` Gets the element at the given index.
    `protected List<WebElement>` | `getElements(Range range)` Gets the elements in the given range.
    `protected List<WebElement>` | `getElements(Collection indexes)` Gets the elements at the given indexes.
    `int` | `getHeight()`
    `JQueryAdapter` | `getJquery()`
    `String` | `getStringRepresentation()`
    `int` | `getWidth()`
    `int` | `getX()`
    `int` | `getY()`
    `Navigator` | `has(String selector)`
    `Navigator` | `has(Map<String, Object> predicates)`
    `Navigator` | `has(Map<String, Object> predicates, String selector)`
    `Navigator` | `has(By bySelector)`
    `Navigator` | `has(Map<String, Object> predicates, By bySelector)`
    `Navigator` | `hasNot(String selector)`
    `Navigator` | `hasNot(Map<String, Object> predicates)`
    `Navigator` | `hasNot(Map<String, Object> predicates, String selector)`
    `Navigator` | `hasNot(By bySelector)`
    `Navigator` | `hasNot(Map<String, Object> predicates, By bySelector)`
    `Iterator<Navigator>` | `iterator()`
    `WebElement` | `lastElement()`
    `T` | `module(Class<T> moduleClass)`
    `T` | `module(T module)`
    `List<T>` | `moduleList(Class<T> moduleClass)`
    `List<T>` | `moduleList(Closure<T> moduleFactory)`
    `Navigator` | `plus(Navigator navigator)`
    `WebElement` | `singleElement()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Property Detail

    - #### final Browser browser

    - #### final Locator locator

  - ### Constructor Detail

    - #### AbstractNavigator(Browser browser, BasicLocator basicLocator)

  - ### Method Detail

    - #### Navigator $(Map<String, Object> predicates)

    - #### @Override Navigator $(Map<String, Object> predicates, int index)

    - #### @Override Navigator $(Map<String, Object> predicates, Range<Integer> range)

    - #### @Override Navigator $(Map<String, Object> predicates, String selector)

    - #### @Override Navigator $(Map<String, Object> predicates, String selector, int index)

    - #### @Override Navigator $(Map<String, Object> predicates, String selector, Range<Integer> range)

    - #### @Override Navigator $(String selector)

    - #### @Override Navigator $(String selector, int index)

    - #### @Override Navigator $(String selector, Range<Integer> range)

    - #### @Override Navigator $(Map<String, Object> predicates, By bySelector)

    - #### @Override Navigator $(Map<String, Object> predicates, By bySelector, int index)

    - #### @Override Navigator $(Map<String, Object> predicates, By bySelector, Range<Integer> range)

    - #### @Override Navigator $(By bySelector)

    - #### @Override Navigator $(By bySelector, int index)

    - #### @Override Navigator $(By bySelector, Range<Integer> range)

    - #### Navigator add(String selector)

    - #### Navigator add(By bySelector)

    - #### Navigator add(WebElement[] elements)

    - #### Navigator add(Collection<WebElement> elements)

    - #### boolean asBoolean()

    - #### String attr(String name)

    - #### String css(String propertyName)

    - #### Navigator eq(int index)

    - #### @Override Navigator filter(Map<String, Object> predicates, String selector)

    - #### Navigator find(Map<String, Object> predicates)

    - #### @Override Navigator find(Map<String, Object> predicates, int index)

    - #### @Override Navigator find(Map<String, Object> predicates, Range<Integer> range)

    - #### @Override Navigator find(Map<String, Object> predicates, String selector)

    - #### @Override Navigator find(Map<String, Object> predicates, String selector, int index)

    - #### @Override Navigator find(Map<String, Object> predicates, String selector, Range<Integer> range)

    - #### @Override Navigator find(String selector)

    - #### @Override Navigator find(String selector, int index)

    - #### @Override Navigator find(String selector, Range<Integer> range)

    - #### @Override Navigator find(Map<String, Object> predicates, By bySelector)

    - #### @Override Navigator find(Map<String, Object> predicates, By bySelector, int index)

    - #### @Override Navigator find(Map<String, Object> predicates, By bySelector, Range<Integer> range)

    - #### @Override Navigator find(By bySelector)

    - #### @Override Navigator find(By bySelector, int index)

    - #### @Override Navigator find(By bySelector, Range<Integer> range)

    - #### Navigator findAll(Closure predicate)

    - #### WebElement firstElement()

    - #### protected WebElement getElement(int index)

      Gets the element at the given index.

      Returns:
        the element at the given index, or null if no such element exists
      Parameters:
        `index` - index of the element to retrieve - pass a negative value to start from the back

    - #### protected List<WebElement> getElements(Range range)

      Gets the elements in the given range.

      Returns:
        the elements in the given range, or an empty list if no such elements exist
      Parameters:
        `range` - range of the elements to retrieve

    - #### protected List<WebElement> getElements(Collection indexes)

      Gets the elements at the given indexes.

      Returns:
        the elements at the given indexes, or an empty list if no such elements exist
      Parameters:
        `indexes` - indexes of the elements to retrieve

    - #### int getHeight()

    - #### JQueryAdapter getJquery()

    - #### @Override String getStringRepresentation()

    - #### int getWidth()

    - #### int getX()

    - #### int getY()

    - #### Navigator has(String selector)

    - #### Navigator has(Map<String, Object> predicates)

    - #### Navigator has(Map<String, Object> predicates, String selector)

    - #### Navigator has(By bySelector)

    - #### Navigator has(Map<String, Object> predicates, By bySelector)

    - #### Navigator hasNot(String selector)

    - #### Navigator hasNot(Map<String, Object> predicates)

    - #### Navigator hasNot(Map<String, Object> predicates, String selector)

    - #### Navigator hasNot(By bySelector)

    - #### Navigator hasNot(Map<String, Object> predicates, By bySelector)

    - #### Iterator<Navigator> iterator()

    - #### WebElement lastElement()

    - #### @SuppressWarnings("UnnecessaryPublicModifier") T module(Class<T> moduleClass)

    - #### @SuppressWarnings("UnnecessaryPublicModifier") T module(T module)

    - #### @SuppressWarnings("UnnecessaryPublicModifier") List<T> moduleList(Class<T> moduleClass)

    - #### @SuppressWarnings(["UnnecessaryPublicModifier", "UnnecessaryCollectCall"]) List<T> moduleList(Closure<T> moduleFactory)

    - #### Navigator plus(Navigator navigator)

    - #### WebElement singleElement()